package com.example.android.snake;

import java.util.ArrayList;
import android.util.Log;
import java.util.List;

import android.content.Context;
import android.media.MediaPlayer;

public class Sound {
	private static final String TAG = "[Sound.java]";
	private static final int tracks_count = 6;
	
	private List<MediaPlayer> inGameTracks;
	private int fearLevel = 0;
	private MediaPlayer musicCredis;
	private boolean is_playing_credits = false;
	
	public Sound(Context cntx) {		
		inGameTracks = new ArrayList<MediaPlayer>();
		
		inGameTracks.add(MediaPlayer.create(cntx, R.raw.m_1));
		inGameTracks.add(MediaPlayer.create(cntx, R.raw.m_2));
		inGameTracks.add(MediaPlayer.create(cntx, R.raw.m_3));
		inGameTracks.add(MediaPlayer.create(cntx, R.raw.m_4));
		inGameTracks.add(MediaPlayer.create(cntx, R.raw.m_5));
		inGameTracks.add(MediaPlayer.create(cntx, R.raw.m_6));
		
		for(MediaPlayer mp: inGameTracks) {
			mp.setLooping(true);
			mp.setVolume(0, 0);
			mp.start();
		}
							
		musicCredis = MediaPlayer.create(cntx, R.raw.m_7);
		musicCredis.setLooping(true);
	}
	
	public void playInGameMusic() {
		is_playing_credits = false;
		for(MediaPlayer mp: inGameTracks) {
			mp.setVolume(0, 0);
			if(mp.isPlaying())
				mp.start();		
		}
		inGameTracks.get(fearLevel).setVolume(1, 1);
	}

	public void pauseMusic() {
		Log.d(TAG,"pauseMusic()");
		for(MediaPlayer mp: inGameTracks) 			
			mp.pause();
		musicCredis.pause();
	}
	
	public void stopMusic() {
		Log.d(TAG,"stopMusic()");
		for(MediaPlayer mp: inGameTracks) 			
			mp.stop();
		musicCredis.stop();
	}
	
	public void resumeMusic() {
		Log.d(TAG,"resumeMusic()");
		if (is_playing_credits) {
			musicCredis.start();
		} else {
			for(MediaPlayer mp: inGameTracks) 
					mp.start();
			inGameTracks.get(fearLevel).setVolume(1, 1);
		}
		
	}

	/**
	 * Heavier music
	 */
	public void moreFear() {		
		Log.d(TAG,"moreFear()");
		if(fearLevel == (tracks_count - 1)) 
			return;
		
		inGameTracks.get(fearLevel).setVolume(0, 0);		
		fearLevel++;		
		inGameTracks.get(fearLevel).setVolume(1, 1);
		Log.d(TAG,"Fear level is "+fearLevel);
	}

	/**
	 * Lighter music
	 */
	public void lessFear() {
		Log.d(TAG,"lessFear()");		
		if(fearLevel == 0) 
			return;
		
		inGameTracks.get(fearLevel).setVolume(0, 0);		
		fearLevel--;		
		inGameTracks.get(fearLevel).setVolume(1, 1);
		
		Log.d(TAG,"Fear level is "+fearLevel);
	}

	public void playCredits() {
		Log.d(TAG,"playCredits()");
		for(MediaPlayer mp: inGameTracks) 
			mp.setVolume(0, 0);
		is_playing_credits = true;
		musicCredis.start();
	}

	public static int getTracksCount() {
		return tracks_count;
	}
}
