package com.example.android.snake;

import java.util.ArrayList;
import java.util.List;

import android.util.Log;
import android.view.MotionEvent;

public class SwipeDetection {

	public List<SwipeObserver> observers = new ArrayList<SwipeObserver>(1);
	// has a touch press started?
	private boolean touchStarted = false;
	// co-ordinates of image
	private int x_init, y_init;

	public void swipeDetected(int[] vectors) {
		if (observers != null)
			for (SwipeObserver o : observers) {
				o.update(vectors);  
			}
	}

	public boolean touchDetection(MotionEvent event) {

		int action = event.getAction();

		if (action == MotionEvent.ACTION_DOWN) {
			touchStarted = true;
			Log.d("TouchTest", "Touch down");
			x_init = (int) event.getX();
			y_init = (int) event.getY();
			System.out.println("Touch Down at: x= " + x_init + " y= " + y_init);
		} else if (action == MotionEvent.ACTION_MOVE) {
			// movement: cancel the touch press
			touchStarted = true;

			// x_init = (int) event.getX();
			// y_init = (int) event.getY();

			Log.d("TouchTest", "Touch move");
			// invalidate(); // request draw
		} else if (action == MotionEvent.ACTION_UP) {
			if (touchStarted) {
				Log.d("TouchTest", "Touch UP");
				int x_final = (int) event.getX();
				int y_final = (int) event.getY();
				System.out.println("Touch UP at: x= " + x_final + " y= "
						+ y_final);
				int distance = distance(x_init, y_init, x_final, y_final);
				System.out.println("Distance between points is: " + distance);
				if (distance >= 50) {
					int[] vectors = calculateVectors(x_init, y_init, x_final,
							y_final);
					swipeDetected(vectors);
				}
				return true;
			}
			return false;
		}

		return true;
	}

	public int distance(int x1, int y1, int x2, int y2) {
		int xdiff = x1 - x2;
		int ydiff = y1 - y2;
		return (int) Math.sqrt(xdiff * xdiff + ydiff * ydiff);
	}

	public int[] calculateVectors(int x1, int y1, int x2, int y2) {
		int[] vectors = new int[2];

		vectors[0] = x1 - x2;
		vectors[1] = y1 - y2;

		return vectors;
	}
}
