package com.example.android.snake.models;
import java.util.Random;

import com.example.android.snake.models.Lunatic;
import com.example.android.snake.models.Map;
import com.example.android.snake.models.Spider;

public class ModelTest {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		
		Spider spider1 = new Spider(1.0,1.0,(short)0,(short)0);
		Lunatic lunatic = new Lunatic(1.0,10.0,(short)0,(short)0);
		Map map = new Map();
		map.initDefaultMap();
				
		assert((int)lunatic.distance(spider1) == 9);
		System.out.println("Distance1: "+lunatic.distance(spider1));
		if(lunatic.isColided(spider1))
			System.out.println("Collision!");
		
		lunatic.moveTo(1, 1);
		spider1.moveTo(10, 10);
		assert((int)lunatic.distance(spider1) == 12) : "Distance is: " + lunatic.distance(spider1);
		System.out.println("Distance2: "+lunatic.distance(spider1));
		if(lunatic.isColided(spider1))
			System.out.println("Collision!");
		
		lunatic.moveTo(1, 1);
		spider1.moveTo(1, 1);
		assert((int)lunatic.distance(spider1) == 0) : "Distance is: " + lunatic.distance(spider1);
		System.out.println("Distance2: "+lunatic.distance(spider1));
		if(lunatic.isColided(spider1))
			System.out.println("Collision!");

		lunatic.moveTo(1, 1);
		spider1.moveTo(1, 2);
		assert((int)lunatic.distance(spider1) == 1) : "Distance is: " + lunatic.distance(spider1);
		System.out.println("Distance3: "+lunatic.distance(spider1));
		if(lunatic.isColided(spider1))
			System.out.println("Collision!");
		
		if(lunatic.isColided(spider1,1))
			System.out.println("Collision tolerance 2!");
		
		lunatic.moveTo(1000, 1500);
		spider1.moveTo(3000, 2);
		assert((int)lunatic.distance(spider1) == 2498) : "Distance is: " + lunatic.distance(spider1);
		System.out.println("Distance3: "+lunatic.distance(spider1));
		if(lunatic.isColided(spider1))
			System.out.println("Collision!");
		
		if(lunatic.isColided(spider1,2499))
			System.out.println("Collision tolerance 3!");
		
		System.out.println("Map vector size: "+map.getMap_size());
		System.out.println("Map x size: "+map.getX_size());
		System.out.println("Map y size: "+map.getY_size());
		
		assert map.isWall(290, 75);
		assert !map.isWall(100, 100);
				
		
		// test game world
		GameWorld world = new GameWorld();
		Random r = new Random();
		int i;
				
		assert !world.isOutsideWorld(0,0);
		assert !world.isOutsideWorld(world.getMax_x(), world.getMax_y());
		
		assert world.isOutsideWorld(-1,0);		
		assert world.isOutsideWorld(0,-1);
		assert world.isOutsideWorld(-1,-1);
		assert world.isOutsideWorld(-1,0);
		
		assert world.isOutsideWorld(world.getMax_x()+1,0);		
		assert world.isOutsideWorld(0,world.getMax_y()+1);
		assert world.isOutsideWorld(world.getMax_x()+1,-1);
		assert world.isOutsideWorld(-1,world.getMax_y()+1);
		
		// check free spice
		assert world.isSomeSpace(100, 100);
		

		assert !world.isSomeSpace(1,0);		
		assert !world.isSomeSpace(0,1);
		assert !world.isSomeSpace(1,1);
		assert !world.isSomeSpace(1,0);
		
		assert !world.isSomeSpace(world.getMax_x(),0);		
		assert !world.isSomeSpace(0,world.getMax_y());
		assert !world.isSomeSpace(world.getMax_x(),-1);
		assert !world.isSomeSpace(-1,world.getMax_y());
		
		
		// looking for free space
//		int[] c = world.startWave(0, 0, 64);
//		world.startWave(0, 0, 64);
//		world.startWave(world.getMax_x(), world.getMax_y(), 64);		
//		for (i = 0; i < 500; i++) 
//			world.startWave(r.nextInt(world.getMax_x()+1), r.nextInt(world.getMax_y()+1), 64);
//		
//		// putting objects				
//		for (i = 0; i < 100; i++) 
//			world.putObject(new Spider(r.nextInt(world.getMax_x()+1),r.nextInt(world.getMax_y()+1),(short)r.nextInt(30),(short)r.nextInt(361)));
//		
		
		//test collision
		// check free spice
		assert world.isSomeSpace(180, 300);
		world.putObject(new Spider(180,300,(short)0,(short)0));
		assert world.isSomeSpace(100, 300);
		world.putObject(new Pillow(100,300,(short)0,(short)10));
		
		
		
		for (i = 0; i < 100; i++){
			System.out.println("Update "+i);
			world.update();
		}
		
		
	}

}